<?php
class SynoFileHostingSimplyPremium {
    private $Url;
    private $Username;
    private $Password;
    private $HostInfo;
    private $SP_COOKIE = '/tmp/simplypremium.cookie';

    public function __construct($Url, $Username, $Password, $HostInfo) {
        $this->Url = $Url;
        $this->Username = $Username;
        $this->Password = $Password;
        $this->HostInfo = $HostInfo;
    }

    //This function verifies and returns account type.
    public function Verify($ClearCookie)
    {
        $curl = curl_init();
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($curl, CURLOPT_USERAGENT, DOWNLOAD_STATION_USER_AGENT);
        curl_setopt($curl, CURLOPT_COOKIEFILE, $this->SP_COOKIE);
        curl_setopt($curl, CURLOPT_COOKIEJAR, $this->SP_COOKIE);
		curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 0);
		curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($curl, CURLOPT_POST, false);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, TRUE);
        curl_setopt($curl, CURLOPT_URL, 'https://www.simply-premium.com/apiV2.php?user');
        $res = curl_exec($curl);
        $user = json_decode($res, true);
        if($user["loggedin"] == false){
            curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);//einloggen
            curl_setopt($curl, CURLOPT_USERAGENT, DOWNLOAD_STATION_USER_AGENT);
            curl_setopt($curl, CURLOPT_COOKIEFILE, $this->SP_COOKIE);
            curl_setopt($curl, CURLOPT_COOKIEJAR, $this->SP_COOKIE);
			curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 0);
			curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
            curl_setopt($curl, CURLOPT_POST, TRUE);
            curl_setopt($curl, CURLOPT_POSTFIELDS, "user=".$this->Username."&pass=".$this->Password);
            curl_setopt($curl, CURLOPT_RETURNTRANSFER, TRUE);
            curl_setopt($curl, CURLOPT_URL, 'https://www.simply-premium.com/apiV2.php?user&login');
            $res = curl_exec($curl);
            $user = json_decode($res, true);
            if($user["loggedin"] != true){
                return LOGIN_FAIL;
            }
        }
        if($user["premium"] == 0){
            $ret = ERR_REQUIRED_PREMIUM;
        }else{
            $ret = USER_IS_PREMIUM;
        }
        curl_close($curl);
        if ($ClearCookie && file_exists($this->SP_COOKIE)) {
            unlink($this->SP_COOKIE);
        }
        return $ret;
    }

    //This function returns download url.
    public function GetDownloadInfo() {
        if($this->Verify(false) == USER_IS_PREMIUM){
            $curl = curl_init();
            curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
            curl_setopt($curl, CURLOPT_USERAGENT, DOWNLOAD_STATION_USER_AGENT);
            curl_setopt($curl, CURLOPT_COOKIEFILE, $this->SP_COOKIE);
            curl_setopt($curl, CURLOPT_COOKIEJAR, $this->SP_COOKIE);
			curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 0);
			curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
            curl_setopt($curl, CURLOPT_POST, false);
            curl_setopt($curl, CURLOPT_RETURNTRANSFER, TRUE);
            curl_setopt($curl, CURLOPT_URL, 'https://www.simply-premium.com/load.php?info&json&link='.$this->Url);
            $res = curl_exec($curl);
            $json = json_decode($res, true);
            $DownloadInfo = array();
            if($json['code'] == 0) {
                $DownloadInfo[DOWNLOAD_FILENAME] = $json['name'];
                $DownloadInfo[DOWNLOAD_URL] = str_replace('https://', 'http://', $json['download']);
                if($json['cacheStatus'] != 's' && $json['cacheStatus'] != 'i'){
                    curl_setopt($curl, CURLOPT_URL, $json['cache']);
                    $json = json_decode(curl_exec($curl), true);
                    $count = 0;
                    while($json['retry_in_seconds'] != 0 && $count <= 10){
                        $json = json_decode(curl_exec($curl), true);
                        $count++;
                        sleep($json['retry_in_seconds']);
                    }
                }
            }else{
                $DownloadInfo[DOWNLOAD_ERROR] = ERR_FILE_NO_EXIST;
            }
            curl_close($curl);
            return $DownloadInfo;
        }else{
            return false;
        }
    }
}